<template>
  <div id="student_class_lecture_grade_wrapper" class="bt-container">
    <div style="display:inline; float: right; margin:25px">
      <a href="javascript:history.back();">
        <el-button size="small">{{ $t('ITEM_FROM_BANK.BACK') }}</el-button>
      </a>
    </div>   
    <h2>{{ currentStudyingClass(classId) ? currentStudyingClass(classId).name : '' }} > {{ $t('STUDENT_MENU.VIEW_RESULTS') }}</h2>

    <div class="one-lecture-wrapper">
      <h3>{{ selectQuestionList.name }}</h3>
      <el-table :data="selectQuestionList.questions">
        <el-table-column
          prop="no"
          label="No."
          width="100px">
        </el-table-column>
        <el-table-column
          prop="type"
          :label="$t('LECTURE_LIST.TYPE')"
          width="100px">
        </el-table-column>
        <el-table-column
          prop="question"
          :label="$t('QUESTION.QUESTION')">
        </el-table-column>
        <el-table-column
          :label="$t('STUDENT_MENU.SUBMIT')"
          width="100px">
          <template slot-scope="scope">
            {{ scope.row.numberOfStudent === 1 ? '제출' : '미제출' }}
          </template>
        </el-table-column>
        <el-table-column
          :label="$t('LECTURE_MANAGE.ALLOTS')"
          width="100px">
          <template slot-scope="scope">
            {{ scope.row.avgScore }} / {{scope.row.score}}
          </template>
        </el-table-column>
        <el-table-column
          label=""
          width="150px">
          <template slot-scope="scope">
            <el-button @click="onClickResult(scope.row.itemId)">{{ $t('GRADE.VIEW_DETAIL') }}</el-button>
          </template>
        </el-table-column>
      </el-table>
    </div>
    <el-dialog :title="$t('STUDENT_MENU.DTL_ITEM_RES_VIEW')" :visible.sync="detailModalVisible" center width="35%">
      <div v-if="questionResult">
        <h3>{{ $t('ITEM.QUESTION') }} ({{ questionResult.type }})</h3>
        <p v-for="material in questionResult.materials" v-bind:key="material">
          <img
            :src="getUrl(material.client_path)"
            width="100%">
        </p>
        <p>{{ questionResult.question }} ({{ questionResult.score }}{{ $t('LECTURE_MANAGE.SCORE') }})</p>

        <!-- <div v-if="questionResult.type === '객관'">
          <el-radio-group style="width: 100%;" disabled>
            <div v-for="(choice,index) in questionResult.choice" :key="index">
              <el-radio :label="index">{{ index + 1 }} . {{ choice }}</el-radio>
            </div>
          </el-radio-group>
        </div> 이렇게 하니까 dialog 밖으로 삐져나감-->

        <div v-if="questionResult.type === '객관'">
          <div v-for="(choice,index) in questionResult.choice" :key="index">
            <p :label="index">{{ index + 1 }} . {{ choice }}</p>
          </div>
        </div>

        <div v-if="questionResult.type === 'SW'">
          <el-row>
            <el-col :span="4">{{ $t('GRADE.SUBMIT_LANG') }}</el-col>
            <el-col :span="20">{{ questionResult.acceptLanguage.join(', ') }}</el-col>
          </el-row>
          <el-row>
            <el-col :span="4">{{ $t('QUESTION.INPUT') }}</el-col>
            <el-col :span="20">{{ questionResult.inputDescription }}</el-col>
          </el-row>
          <el-row>
            <el-col :span="4">{{ $t('QUESTION.OUTPUT') }}</el-col>
            <el-col :span="20">{{ questionResult.outputDescription }}</el-col>
          </el-row>
          <el-row>
            <el-col :span="4">{{ $t('QUESTION.INPUT_SAMPLE') }}</el-col>
            <el-col :span="20">{{ questionResult.sampleInput }}</el-col>
          </el-row>
          <el-row>
            <el-col :span="4">{{ $t('QUESTION.OUTPUT_SAMPLE') }}</el-col>
            <el-col :span="20">{{ questionResult.sampleOutput }}</el-col>
          </el-row>
          <el-row>
            <el-col :span="4">{{ $t('QUESTION.TIME_LIMIT') }}</el-col>
            <el-col :span="20">{{ questionResult.timeLimit }}{{ $t('QUESTION.SECOND') }}</el-col>
          </el-row>
          <el-row>
            <el-col :span="4">{{ $t('QUESTION.MEM_LIMIT') }}</el-col>
            <el-col :span="20">{{ questionResult.memoryLimit }}MB</el-col>
          </el-row>
        </div>

        <h3>{{ $t('STUDENT_MENU.SUBMIT_ANSWER') }}</h3>
        <div v-if="questionResult.summitted">
          <p v-for="(answer) in questionResult.answers[0].answer" :key="answer">
            {{ answer }}
          </p>
        </div>
        <div v-else>
          <p>( {{ $t('STUDENT_MENU.NOT_SUBMIT') }} )</p>
        </div>

        <!--
        <div v-if="['객관', '단답', '서술', 'SQL'].includes(questionResult.type)">
          <h3>정답</h3>
          <p>{{ questionResult.answer }}</p>
        </div>
        -->
        <div v-if="questionResult.type === 'SW' && questionResult.summitted">
          <h3>{{ $t('QUESTION.RESULT') }}</h3>
          <p>{{ questionResult.answers[0].swResult }}</p>
          <p>{{ questionResult.answers[0].oj_solution.time }}ms, {{ questionResult.answers[0].oj_solution.memory }}KB</p>
          <p v-if="questionResult.answers[0].swResult === '컴파일 에러'">{{ questionResult.answers[0].oj_compileinfo.error }}</p>
          <p v-if="questionResult.answers[0].swResult === '런타임 에러'">{{ questionResult.answers[0].oj_runtimeinfo.error }}</p>
        </div>

        <h3>{{ $t('LECTURE_MANAGE.ALLOTS') }}</h3>
        <p v-if="questionResult.summitted && questionResult.score === questionResult.avgScore">{{ questionResult.avgScore }} / {{questionResult.score}} ({{$t('RESULT.CALL_CRRT_ANSW')}}) </p>
        <p v-else-if="questionResult.summitted && questionResult.avgScore === 0">{{ questionResult.avgScore }} / {{questionResult.score}} ({{$t('RESULT.CALL_INCRRT_ANSW')}}) </p>
        <p v-else-if="questionResult.summitted && questionResult.score > questionResult.avgScore">{{ questionResult.avgScore }} / {{questionResult.score}} ({{$t('RESULT.CALL_PART_CORRT_ANSW')}}) </p>
        <p v-else-if="!questionResult.summitted">0 / {{questionResult.score}} </p>
      </div>
    </el-dialog>
  </div>
</template>

<style lang="scss" scoped>
  #student_class_lecture_grade_wrapper {
    .one-lecture-wrapper {
      margin-bottom: 40px;
    }
  }
</style>

<script>
import { mapActions, mapState, mapGetters } from 'vuex';
import { baseUrl } from '../../services/config';


export default {
  name: 'StudentClassLectureGrade',
  async beforeMount() {
    const vm = this;
    await vm.getClassTotalResult({
      classId: vm.classId,
      isStudent: true,
    });
    vm.selectQuestionList = [];
    vm.questionList.forEach((x) => {
      if (x.lectureId === vm.lectureId) {
        vm.selectQuestionList.lectureId = x.lectureId;
        vm.selectQuestionList.name = x.name;
        vm.selectQuestionList.questions = x.questions;
      }
    });
  },
  data() {
    return {
      detailModalVisible: false,
      selectQuestionList: [],
    };
  },
  computed: {
    ...mapState('grading', [
      'theResult',
      'questionList',
      'questionResult',
    ]),
    ...mapGetters('NNclass', [
      'currentStudyingClass',
    ]),
    classId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.classId, 10);
    },
    lectureId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.lectureId, 10);
    },
  },
  methods: {
    ...mapActions('grading', [
      'getClassTotalResult',
      'getQuestionResult',
    ]),
    onClickResult(itemId) {
      const vm = this;
      vm.getQuestionResult({ itemId });
      vm.detailModalVisible = true;
    },
    getUrl(arg) {
      return baseUrl + arg;
    },
  },
};
</script>

